//
//  firstViewModel.m
//  TestCoreAnimation
//
//  Created by 黄梦炜 on 2017/11/27.
//  Copyright © 2017年 黄梦炜. All rights reserved.
//

#import "firstViewModel.h"
#define tableID @"imageTableList"
#import "pushToViewController.h"

@interface firstViewModel ()
@property (nonatomic, strong) NSArray *dataArrayList;
@end

@implementation firstViewModel

-(NSArray *)dataArrayList
{
    if (_dataArrayList == nil) {
        _dataArrayList = [NSMutableArray array];
    }
    return _dataArrayList;
}

-(void)getModelDate //数据获取
{
    NSMutableArray *array = [NSMutableArray arrayWithObjects:@"dogSmall", @"dogSmall", @"dogSmall", nil];
    NSMutableArray *arrayModel = [NSMutableArray array];
    for (NSString *str in array) {
        firstModel *model = [firstModel new];
        model.imageUrl = str;
        model.imageIntro = str;
        [arrayModel addObject:model];
    }
    
    _dataArrayList = arrayModel;
    
}

-(void)createTable:(UITableView *)table
{
    table.delegate = self;
    table.dataSource = self;
    
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 100;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _dataArrayList.count;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section
{
    return 0.001;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 0.001;
}
-(UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section
{
    return [UIView new];
}
-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    return [UIView new];
}


-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
        
    static NSString *identifier = tableID;
    //b.去重用队列中根据标识符取可重用的 cell
    firstModel *Model = _dataArrayList[indexPath.row];
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    //c. 判断是否获取到可重用的 cell( 最后要空间释放 )
    if (!cell) {//!cell 相当于 cell == nil
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:identifier];
//        cell.accessoryType = UITableViewCellAccessoryDetailDisclosureButton;//辅助标示类型
        [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
    }
    
    [cell.textLabel setText:Model.imageIntro];
    [cell.imageView setImage:[UIImage imageNamed:Model.imageUrl]];
    return cell;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    firstModel *model = _dataArrayList[indexPath.row];
//    UIViewController *controller =objc_getAssociatedObject(self, &fromViewController);
//    pushToViewController *push = [[pushToViewController alloc] init];
//    push.model = model;
//    [controller presentViewController:push animated:YES completion:nil];
    
    if ([_delegate respondsToSelector:@selector(clickRow:firstModel:)]) {
        [_delegate clickRow:indexPath.row firstModel:model];
    }
    
}




@end
