//
//  pushToViewController.m
//  TestCoreAnimation
//
//  Created by 黄梦炜 on 2017/11/27.
//  Copyright © 2017年 黄梦炜. All rights reserved.
//

#import "pushToViewController.h"
#define ImageHeight 234
#import "secondViewModel.h"
#import "firstViewController.h"
#import "SecondTransition.h"
@interface pushToViewController ()<UINavigationControllerDelegate>
@property (nonatomic, strong) secondViewModel *secondViewModel;

@property (nonatomic, strong) UILabel *imageIntro;     //图片介绍
@end

@implementation pushToViewController


- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    self.navigationController.delegate = self;
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    if (self.navigationController.delegate == self) {
        self.navigationController.delegate = nil;
    }
}

-(id<UIViewControllerAnimatedTransitioning>)navigationController:(UINavigationController *)navigationController animationControllerForOperation:(UINavigationControllerOperation)operation fromViewController:(UIViewController *)fromVC toViewController:(UIViewController *)toVC{
    if (fromVC == self && [toVC isKindOfClass:[firstViewController class]]) {
        return [[SecondTransition alloc] init];
    }
    return nil;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    [self.view setBackgroundColor:[UIColor whiteColor]];
    [self.view addSubview:self.imageHead];
    [self.view addSubview:self.imageIntro];
    [self setView];
    // Do any additional setup after loading the view.
}

-(secondViewModel *)secondViewModel
{
    if (_secondViewModel == nil) {
        _secondViewModel = [[secondViewModel alloc] init];
        
    }
    
    return _secondViewModel;
}

-(UIImageView *)imageHead
{
    if (_imageHead == nil) {
        _imageHead = [[UIImageView alloc] initWithFrame:CGRectMake(0, 64, screen_width, ImageHeight)];
        [_imageHead setBackgroundColor:[UIColor cyanColor]];
        
    }
    return _imageHead;
}

-(UILabel *)imageIntro
{
    if (_imageIntro == nil) {
        _imageIntro = [[UILabel alloc] initWithFrame:CGRectMake(0, ImageHeight + 64, screen_width, screen_height - ImageHeight)];
        [_imageIntro setTextAlignment:NSTextAlignmentCenter];
        [_imageIntro setNumberOfLines:0];
        [_imageIntro setText:@"sdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdfasdf"];
    }
    return _imageIntro;
}

-(void)setView
{
   
    
    NSArray *array = [NSArray arrayWithObjects:_imageHead, _imageIntro, nil];
    [self.secondViewModel setControllerView:array model:_model];
    
    

}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
